#include <eo>
#include <iostream> 

#include <tcl.h>
#include <tk.h>


#include "fitness.h"

using namespace std;


// todo: get rid of global stuff
bool bstop;
bool bexit;
bool bnext; 
bool bprint;
bool bconfig; 
bool bshow; 

int stop( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  printf("--------- STOP ----------- \n");
  bstop = true;
  return 0;
} 

int cont( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  printf("--------- CONTINUE ----------- \n");
  bstop = false;
  return 0;
} 

int exit( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  printf("--------- EXIT ----------- \n");
  bstop = false; 
  bexit = true;
  return 0;
} 

int next( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  printf("--------- NEXT ----------- \n");
  bnext = true;
  return 0;
} 


int print( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  printf("--------- PRINT ----------- \n");
  bprint = true;
  return 0;
} 

int show( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  printf("--------- SHOW ----------- \n");
  bshow = true;
  return 0;
} 


int config( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  bconfig = true;
  return 0;
} 


class myGui : public eoContinue<Keywords> {

public:

  myGui(double _from=0.0, double _to=1.0) : crossRate(dummy), mutRate(dummy) {  
    bstop = true; bexit = false; bprint=false; 
    iter=0; from = _from; to = _to; 
    crossRateValid = mutRateValid = false; 
    Init(); 
  }; 

  myGui(double* _crossRate, double* _mutRate, 
	double _from=0.0, double _to=1.0,
	string _plotName="") : crossRate(*_crossRate), mutRate(*_mutRate) {  
    bstop = true; bexit = false; bprint=false; 
    iter=0; from = _from; to = _to; 
    crossRateValid = mutRateValid = true; 
    Init(); 
    plotName = _plotName;
  }; 


  void Init() {
    interp = Tcl_CreateInterp() ;
    Tcl_Init(interp);

    int ret;
    ret = Tk_Init(interp);
  
    if (ret != TCL_OK) {
      printf("Unable to initialize TK.\n");
      printf(interp->result);
    } 

    Tcl_CreateCommand( interp, "c_stop", stop, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_continue", cont, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_exit", exit, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_next", next, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_print", print, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_show", show, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_config", config, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );

    ret = Tcl_EvalFile(interp, "gui/gui.txt");
    /*
    ret = Tcl_VarEval(interp,
		      "frame .main\n",
		      "button .main.button1 -text \"Stop\" -command { c_stop }\n",
		      "pack .main.button1 -side top -fill x\n",
		      "button .main.button2 -text \"Continue\" -command { c_continue  }\n",
		      "pack .main.button2 -side top -fill x\n",
		      "button .main.button3 -text \"Next\" -command { c_next }\n", 
                      "pack .main.button3 -side top -fill x\n", 
		      "button .main.button4 -text \"Print pop\" -command { c_print  }\n",
                      "pack .main.button4 -side top -fill x\n", 
		      "button .main.button5 -text \"Exit\" -command { c_exit  }\n", 
                      "pack .main.button5 -side top -fill x\n", 
                      "pack .main -side top\n",0);
    */
  
    if (ret != TCL_OK) {
      printf("Error during initial script.\n");
      printf(interp->result); 
    }

    char strFrom[10]; snprintf(strFrom,9,"%lf",from);  
    char strTo[10]; snprintf(strTo,9,"%lf",to);  
    Tcl_SetVar(interp, "f", strFrom, 0); 
    Tcl_SetVar(interp, "t", strTo, 0); 

  } 

  /*
  void draw(double value) {

    return; // nekreslit graf

    const char *x = Tcl_GetVar(interp,"x",0);
    const char *y = Tcl_GetVar(interp,"y",0);
    const char *h = Tcl_GetVar(interp,"h",0);
    const char *f = Tcl_GetVar(interp,"f",0);
    const char *t = Tcl_GetVar(interp,"t",0);

    
    char x2[50];
    char xm[50];
    char y2[50];

    if (value < from) { value = from; printf("Warning: fitness out of range of graph.\n"); }
    if (value > to ) { value = to; printf("Warning: fitness out of range of graph.\n"); }

    sprintf(y2,"%lf",(atof(t)-value)*atof(h)/(atof(t)-atof(f)));
     
    //    printf( y2 );

    if (!strcmp(y,"start")) { // first call -  set initial value
      Tcl_SetVar(interp, "y", y2, 0);
      return; 
    } 

    // draw line
    sprintf(x2,"%i",atoi(x)+5);
    sprintf(xm,"%i",atoi(x)-5000); // ??? tune the constant

    char drawline[100]; 
    char deltag[100]; 
    char conf[100]; 
    
    snprintf(drawline,99, 
	     ".graph.c create line %s %s %s %s  -fill red -width 2 -tag x2\n",
	     x,y, 
	     x2,y2); 

    snprintf(deltag,99, 
	     ".graph.c delete tag x %s\n",
	     xm); 

    snprintf(conf,99,
	     ".graph.c configure -scrollregion { %s 0 %s %s }\n",
	     xm, x2, h); 


    //    printf("%s %s %s",drawline, deltag, conf);

    int ret = Tcl_VarEval(interp,
			  drawline,deltag, conf, 
			  ".graph.c xview moveto 1\n", 
			  0);

    if (ret != TCL_OK) {
      printf("Drawing to graph failed.\n");
      printf(interp->result);
    }

    Tcl_SetVar(interp, "x", x2, 0);
    Tcl_SetVar(interp, "y", y2, 0);
  } 

  */

  virtual bool operator()(const eoPop<Keywords>& _pop) {

    
    //    
    cout << iter << ": "<<  _pop.best_element().fitness() << " " << _pop.best_element().size() << endl;
    //

    Tcl_SetVar(interp, "Generace",strIter(),0);
    double bestFit = _pop.best_element().fitness();
    Tcl_SetVar(interp, "Fitnes",strFitness(bestFit),0); 

    if (bstop) {
      if (crossRateValid) Tcl_SetVar(interp,"Cross",strDouble(crossRate),0);
      if (mutRateValid) Tcl_SetVar(interp,"Mut",strDouble(mutRate),0);
    }

    //    draw(bestFit); 
    iter++;


    bnext = false; 
    while (bstop && !bnext) { 

      Tcl_DoOneEvent(TCL_ALL_EVENTS);
 
      if (bprint) {
	eoPop<Keywords> myPop  = _pop;
	myPop.sort();
	cout << myPop;
	bprint = false; 
      } 
    
      if (bshow) {
	const Keywords& best = _pop.best_element(); 
	// uloz jedince  
	FILE* f = fopen("best_tmp.txt","w");
	
	for (unsigned i=0; i<best.size(); i++) {
	  for (unsigned j=0; j<best[i].size(); j++) 
	    fprintf(f,"%lf ",best[i][j]);
	  fprintf(f,"\n");
	} 
	fclose(f);

	
	FILE* plot = fopen("plot_tmp.txt","w");
	fprintf(plot,"plot \"%s\" t \"data\" \n",plotName.c_str());
	fprintf(plot,"replot \"best_tmp.txt\" t \"stredy\" ps 3 pt 5 \n"); 
	fprintf(plot,"pause -1 \"Press Enter to continue\"\n");
	fclose(plot);
	  
	system("gnuplot plot_tmp.txt");
	
	bshow = false;
      } 

      if (bconfig) {

	if (crossRateValid) {
	  double newCross = atof( Tcl_GetVar(interp,"Cross",0) );
	  if (newCross < 0.0 || newCross > 1.0) 
	    cout << "Crossover rate: out of range." << endl; 
	  else 
	    crossRate = newCross; 
	} 

	if (mutRateValid) {
	  double newMut = atof(Tcl_GetVar(interp,"Mut",0));
	  if (newMut < 0.0 || newMut > 1.0) 
	    cout << "Mutation rate: out of range." << endl; 
	  else 
	    mutRate = newMut; 
	} 

	bconfig = false; 
      }
    }; 
   
    while (Tcl_DoOneEvent(TCL_ALL_EVENTS | TCL_DONT_WAIT)) 
      ;

    
    return !bexit;
  }

  
private:
  Tcl_Interp *interp; 
  int iter; 
  
  double from, to; 

  char buf1[20]; // buffer for iter 
  char buf2[20]; // buffer for fitness  
  char buf3[20]; // buffer for fitness  

  const char *strIter() { snprintf(buf1,19,"%d",iter); return buf1; };
  const char *strFitness(double fitness) {  snprintf(buf2,19,"%lf",fitness); return buf2; }; 
  const char *strDouble(double x) {  snprintf(buf3,19,"%.2lf",x); return buf3; }; 

  double &crossRate;
  bool crossRateValid; 

  double &mutRate; 
  bool mutRateValid; 

  double dummy;

  string plotName;
};
